local ffi = require 'ffi'
local lj_include = require 'lj_include'
local defs = {
    TIOCEXCL = '0x540C',
    TIOCNXCL = '0x540D',
    TIOCSCTTY = '0x540E',
    TIOCSTI = '0x5412',
    TIOCMGET = '0x5415',
    TIOCMBIS = '0x5416',
    TIOCMBIC = '0x5417',
    TIOCMSET = '0x5418',
    TIOCM_LE = '0x001',
    TIOCM_DTR = '0x002',
    TIOCM_RTS = '0x004',
    TIOCM_ST = '0x008',
    TIOCM_SR = '0x010',
    TIOCM_CTS = '0x020',
    TIOCM_CAR = '0x040',
    TIOCM_RNG = '0x080',
    TIOCM_DSR = '0x100',
    TIOCM_CD = '0x040',
    TIOCM_RI = '0x080',
    TIOCM_OUT1 = '0x2000',
    TIOCM_OUT2 = '0x4000',
    TIOCM_LOOP = '0x8000',
    TIOCGSOFTCAR = '0x5419',
    TIOCSSOFTCAR = '0x541A',
    TIOCLINUX = '0x541C',
    TIOCCONS = '0x541D',
    TIOCGSERIAL = '0x541E',
    TIOCSSERIAL = '0x541F',
    TIOCPKT = '0x5420',
    TIOCPKT_DATA = '0',
    TIOCPKT_FLUSHREAD = '1',
    TIOCPKT_FLUSHWRITE = '2',
    TIOCPKT_STOP = '4',
    TIOCPKT_START = '8',
    TIOCPKT_NOSTOP = '16',
    TIOCPKT_DOSTOP = '32',
    TIOCPKT_IOCTL = '64',
    TIOCNOTTY = '0x5422',
    TIOCSETD = '0x5423',
    TIOCGETD = '0x5424',
    TCSBRKP = '0x5425',
    TIOCSBRK = '0x5427',
    TIOCCBRK = '0x5428',
    TIOCGSID = '0x5429',
    TIOCGRS485 = '0x542e',
    TIOCSRS485 = '0x542f',
    TIOCVHANGUP = '0x5437',
    TIOCSERCONFIG = '0x5453',
    TIOCSERGWILD = '0x5454',
    TIOCSERSWILD = '0x5455',
    TIOCGLCKTRMIOS = '0x5456',
    TIOCSLCKTRMIOS = '0x5457',
    TIOCSERGSTRUCT = '0x5458',
    TIOCSERGETLSR = '0x5459',
    TIOCSER_TEMT = '0x01',
    TIOCSERGETMULTI = '0x545A',
    TIOCSERSETMULTI = '0x545B',
    TIOCMIWAIT = '0x545C',
    TIOCGICOUNT = '0x545D',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

