local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('stddef')
lj_include('bits_time')
lj_include('bits_types')

ffi.cdef[[
typedef __clock_t clock_t;
typedef __time_t time_t;
typedef __clockid_t clockid_t;
typedef __timer_t timer_t;
struct timespec {
    __time_t tv_sec;
    long int tv_nsec;
};
struct tm {
    int tm_sec;
    int tm_min;
    int tm_hour;
    int tm_mday;
    int tm_mon;
    int tm_year;
    int tm_wday;
    int tm_yday;
    int tm_isdst;
    long int tm_gmtoff;
    const char *tm_zone;
};
struct itimerspec {
    struct timespec it_interval;
    struct timespec it_value;
};
struct sigevent;
typedef __pid_t pid_t;
clock_t clock(void);
time_t time(time_t * __timer);
double difftime(time_t __time1, time_t __time0);
time_t mktime(struct tm *__tp);
size_t strftime(char *__s, size_t __maxsize,
    const char *__format, const struct tm *__tp);
char *strptime(const char *__s, const char *__fmt, struct tm *__tp);
]]

lj_include('xlocale')

ffi.cdef[[
size_t strftime_l(char *__s, size_t __maxsize,
    const char *__format, const struct tm *__tp, __locale_t __loc);
char *strptime_l(const char *__s,
    const char *__fmt, struct tm *__tp, __locale_t __loc);
struct tm *gmtime(const time_t * __timer);
struct tm *localtime(const time_t * __timer);
struct tm *gmtime_r(const time_t * __timer, struct tm *__tp);
struct tm *localtime_r(const time_t * __timer, struct tm *__tp);
char *asctime(const struct tm *__tp);
char *ctime(const time_t * __timer);
char *asctime_r(const struct tm *__tp, char *__buf);
char *ctime_r(const time_t * __timer, char *__buf);
char *__tzname[2];
int __daylight;
long int __timezone;
char *tzname[2];
void tzset(void);
int daylight;
long int timezone;
int stime(const time_t * __when);
time_t timegm(struct tm *__tp);
time_t timelocal(struct tm *__tp);
int dysize(int __year);
int nanosleep(const struct timespec *__requested_time,
    struct timespec *__remaining);
int clock_getres(clockid_t __clock_id, struct timespec *__res);
int clock_gettime(clockid_t __clock_id, struct timespec *__tp);
int clock_settime(clockid_t __clock_id, const struct timespec *__tp);
int clock_nanosleep(clockid_t __clock_id, int __flags,
    const struct timespec *__req, struct timespec *__rem);
int clock_getcpuclockid(pid_t __pid, clockid_t * __clock_id);
int timer_create(clockid_t __clock_id,
    struct sigevent *__evp, timer_t * __timerid);
int timer_delete(timer_t __timerid);
int timer_settime(timer_t __timerid, int __flags,
    const struct itimerspec *__value, struct itimerspec *__ovalue);
int timer_gettime(timer_t __timerid, struct itimerspec *__value);
int timer_getoverrun(timer_t __timerid);
int getdate_err;
struct tm *getdate(const char *__string);
int getdate_r(const char *__string, struct tm *__resbufp);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

