require('lj_include'){
    'sys/select',
}

local bit = require 'bit'
local lshift = bit.lshift
local band = bit.band
local bor = bit.bor
local bnot = bit.bnot
local ffi = require 'ffi'
local C = ffi.C

ffi.cdef[[
enum {
    __NFDBITS = 32
};
]]

local sio = {}

-- __FD* taken from sys/select.h
local function __FDELT(d)
    return ffi.new('int', d / C.__NFDBITS)
end

local function __FDMASK(d)
    return ffi.new('__fd_mask', lshift(1, ffi.new('int', d % C.__NFDBITS)))
end

-- FD_* taken from bits/select.h
function sio.FD_ZERO(s)
    for i = 0, ffi.sizeof('fd_set') / ffi.sizeof('__fd_mask') do
        s[0].fds_bits[i] = 0
    end
end

function sio.FD_SET(d, s)
    local a = s[0].fds_bits[__FDELT(d)]
    local b = __FDMASK(d)
    s[0].fds_bits[__FDELT(d)] = bor(a, b)
end

function sio.FD_CLR(d, s)
    local a = s[0].fds_bits[__FDELT(d)]
    local b = bnot(__FDMASK(d))
    s[0].fds_bits[__FDELT(d)] = band(a, b)
end

function sio.FD_ISSET(d, s)
    local a = s[0].fds_bits[__FDELT(d)]
    local b = __FDMASK(d)
    return band(a, b) ~= 0
end

return sio, C
