(function($) {
    $.extend(true, window, { Slick: { Formatters: {
        ArmadaLive: function(row, cell, value, columnDef, dataContext) {
            var live_readings = columnDef._live_readings;
            var key = dataContext[columnDef._live_key];
            var alr_key = live_readings[key];
            if (alr_key == null)
                alr_key = live_readings[key] = {};
            var alr = alr_key[dataContext.id];
            if (alr == null || alr[0] !== row || alr[1] !== cell)
                alr = live_readings[key][dataContext.id] = [row, cell];
            return '<span class="live">' + value + '</span>';
        },
        ArmadaCheckbox: function(row, cell, value, columnDef, dataContext) {
            return value ? '<input type="checkbox" checked>' :
                '<input type="checkbox">';
        }
    }}});
    $.extend(true, window, { Slick: { Editors: {
        ArmadaCheckbox: function(args) {
            var $checkbox;
            var field = args.column.field;

            this.init = function() {
                args.item[field] = !args.item[field]; // KLUDGE?
                $checkbox = $('<input type="checkbox">')
                    .appendTo(args.container);
                $checkbox.change(function(ev){
                    args.item[field] = $checkbox.is(':checked');
                });
                this.loadValue(args.item);
                this.focus();
            };
            this.destroy = function() {
            };
            this.getValue = function() {
                return $checkbox.is(':checked');
            };
            this.focus = function() {
                $checkbox.focus();
            };
            this.serializeValue = function() {
                return $checkbox.is(':checked');
            };
            this.applyValue = function(item, state) {
                item[field] = state;
            };
            this.loadValue = function(item) {
                $checkbox.attr('checked', item[field]); // KLUDGE JQ 1.6 broken
            };
            this.isValueChanged = function() {
                return Boolean(args.item[field]) !== $checkbox.is(':checked');
            };
            this.validate = function() {
                return {valid: true, msg: null};
            };

            this.init();
        }
    }}});
}(jQuery));
